#include<iostream>
#include<algorithm>
#include<queue>
#define MAXN 200000
#define INFINITY 1e18
using namespace std;
struct edge {
    int to;
    long long int data[2];
};
vector <edge> a[MAXN];
int n;
bool used[MAXN];
long long int dist[MAXN];
long long int algorithm (int ind, long long int limit) {
    for (int i=0; i<n; i++) {
        dist[i]=INFINITY;
        used[i]=false;
    }
    priority_queue <pair <long long int, int>, vector <pair <long long int, int> >, greater<>> best;
    best.push({0, 0});
    dist[0]=0;
    long long int max1=0;
    for (;;) {
        if (best.empty()==true) return -1;
        auto [d, vr]=best.top();
        best.pop();
        if (used[vr]==true) continue;
        used[vr]=true;
        max1=max(max1,d);
        if (vr==n-1) return max1;
        for (auto [to, data] : a[vr]) {
            if ((used[to]==true)||(data[0]>limit)) continue;
            if ((ind==0)&&(data[0]<dist[to])) {
                dist[to]=data[0];
                best.push({dist[to], to});
            }
            if ((ind==1)&&(d+data[1]<dist[to])) {
                dist[to]=d+data[1];
                best.push({dist[to], to});
            }
        }
    }
}
long long int dfs (int vr, long long int max1, int dep) {
    if (vr==n-1) return max1;
    if (used[vr]==true) return 0;
    used[vr]=true;
    if (dep>12) {
        used[vr]=false;
        return 0;
    }
    long long int min1=INFINITY;
    for (auto [to, data] : a[vr]) {
        auto res=dfs(to,max(max1,data[0]),dep+1);
        if (res!=0) min1=min(min1,res);
    }
    used[vr]=false;
    return (min1==INFINITY)?0:min1;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int m;
    cin >> n >> m ;
    for (int i=0; i<m; i++) {
        int x,y;
        long long int p,w;
        cin >> x >> y >> p >> w ;
        x--; y--;
        a[x].push_back({y, p, w});
        a[y].push_back({x, p, w});
    }
    /*for (int i=0; i<n; i++) {
        sort(a[i].begin(),a[i].end(),[] (const edge& l, const edge& r) {
             if (l.data[0]<r.data[0]) return true;
             return false;
        });
    }*/
    long long int limit=dfs(0,0,0);//algorithm(0,INFINITY);
    cout << limit << " " << algorithm(1,limit) ;
    cout << endl ;
    return 0;
}
