#include<bits/stdc++.h>
#define ll long long
#define f first
#define s second
using namespace std;
const ll maxn=2e5+10;
ll n,m;
struct Edge
{
    ll to,p,c;
};
vector<Edge> edges[maxn];
bool visited[maxn];
ll bfs(ll limit)
{
    queue<ll> q;
    vector<ll> depth(n+1,0);
    vector<bool> visited(n+1,0);
    q.push(1);
    visited[1]=1;
    while(!q.empty())
    {
        ll curr=q.front();
        q.pop();
        for(auto e:edges[curr])
        {
            if(visited[e.to] || e.p>limit) continue;
            q.push(e.to);
            visited[e.to]=1;
            depth[e.to]=depth[curr]+1;
        }
    }
    return depth[n];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    ll mxp=0;
    ll c_all;
    for(ll i=0;i<m;i++)
    {
        ll u,v,tp,tc;
        cin>>u>>v>>tp>>tc;
        edges[u].push_back({v,tp,tc});
        edges[v].push_back({u,tp,tc});
        mxp=max(mxp,tp);
        c_all=tc;
    }
    ll l=1,r=mxp+1;
    while(l!=r)
    {
        ll mid=(l+r)/2;
        if(bfs(mid)) r=mid;
        else l=mid+1;
    }
    cout<<l<<" "<<bfs(l)*c_all<<"\n";
}
/*
5 7
1 3 7 5
1 5 7 5
2 4 3 5
2 5 2 5
1 2 2 5
3 5 2 5
4 5 7 5
*/


