#include<bits/stdc++.h>
#define ll long long
#define f first
#define s second
using namespace std;
const int maxn=2e5+10;
int n,m;
struct Edge
{
    ll to,p,c;
};
vector<Edge> edges[maxn];
bool visited[maxn];
ll Dijkstra()
{
    priority_queue<pair<ll,ll>> pq;
    vector<ll> dist(n+1,LLONG_MAX/2);
    pq.push({0,1});
    dist[1]=0;
    while(!pq.empty())
    {
        ll curr=pq.top().s;
        ll path=-pq.top().f;
        pq.pop();
        if(dist[curr]<path) continue;
        for(auto e:edges[curr])
        {
            if(dist[e.to]>path+e.c)
            {
                dist[e.to]=path+e.c;
                pq.push({-dist[e.to],e.to});
            }
        }
    }
    return dist[n];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    ll p_all;
    for(int i=0;i<m;i++)
    {
        ll u,v,tp,tc;
        cin>>u>>v>>tp>>tc;
        edges[u].push_back({v,tp,tc});
        edges[v].push_back({u,tp,tc});
        p_all=tp;
    }
    cout<<p_all<<" "<<Dijkstra()<<"\n";
}
/*
5 7
1 3 5 5
1 5 5 6
2 4 5 1
2 5 5 6
1 2 5 2
3 5 5 1
4 5 5 2
*/



