#include<iostream>
#include<unordered_set>
#include<assert.h>
#include<queue>
#define MAXN 200000
#define INFINITY 1e18
using namespace std;
struct edge {
    int to;
    long long int data[2];
};
vector <edge> a[MAXN];
int n;
bool used[MAXN];
long long int dist[MAXN];
long long int algorithm (int ind, long long int limit) {
    for (int i=0; i<n; i++) {
        dist[i]=INFINITY;
        used[i]=false;
    }
    priority_queue <pair <long long int, int>, vector <pair <long long int, int> >, greater<>> best;
    best.push({0, 0});
    dist[0]=0;
    long long int max1=0;
    for (;;) {
        assert(best.empty()==false);
        auto [d, vr]=best.top();
        best.pop();
        if (used[vr]==true) continue;
        used[vr]=true;
        max1=max(max1,d);
        if (vr==n-1) return max1;
        for (auto [to, data] : a[vr]) {
            if ((used[to]==true)||(data[0]>limit)) continue;
            if ((ind==0)&&(data[0]<dist[to])) {
                dist[to]=data[0];
                best.push({dist[to], to});
            }
            if ((ind==1)&&(d+data[1]<dist[to])) {
                dist[to]=d+data[1];
                best.push({dist[to], to});
            }
        }
    }
}
//unordered_set <long long int> edges;
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int m;
    assert(cin >> n >> m );
    assert((2<=n)&&(n<=MAXN));
    assert((1<=m)&&(m<=3e5));
    for (int i=0; i<m; i++) {
        int x,y;
        long long int p,w;
        assert(cin >> x >> y >> p >> w );
        assert((1<=x)&&(x<=n));
        assert((1<=y)&&(y<=n));
        assert((1<=p)&&(p<=1e18));
        assert((1<=w)&&(w<=5e12));
        assert(x!=y);
        x--; y--;
        /*auto [it, flag]=edges.insert(min(x,y)*1LL*n+max(x,y));
        assert(flag==true);*/
        a[x].push_back({y, p, w});
        a[y].push_back({x, p, w});
    }
    char tmp;
    assert(!(cin >> tmp ));
    long long int limit=algorithm(0,INFINITY);
    cout << limit << " " << algorithm(1,limit) ;
    cout << endl ;
    return 0;
}
