/* the checker has three arguments:
   - first - name of the input file
   - second - name of the correct output file
   - third - name of the contestant output file */
#include<iostream>
#include<fstream>
#include<string>
#include<math.h>
using namespace std;
void output_message (double points, string message) {
    cout << points << endl ;
    cerr << message << endl ;
    exit(0);
}
int main (int argc, char** argv) {
    ifstream inp,ans,out;
    if (argc<4) output_message(0,"The checker needs input file, correct output and contestant output!");
    inp.open(argv[1]);
    if (inp.is_open()==false) output_message(0,"Could not open input file!");
    ans.open(argv[2]);
    if (ans.is_open()==false) output_message(0,"Could not open correct output file!");
    out.open(argv[3]);
    if (out.is_open()==false) output_message(0,"Could not open contestant output file!");

    long long int ans1,ans2;
    if (!(ans >> ans1)) output_message(0,"Could not read answer output!");
    if (!(ans >> ans2)) output_message(0,"Could not read answer output!");
    char temp;
    if (ans >> temp) output_message(0,"Extra answer output!");

    long long int out1,out2;
    if (!(out >> out1)) output_message(0,"Could not read output!");
    if (!(out >> out2)) output_message(0,"Could not read output!");
    if (out >> temp) output_message(0,"Extra output!");

    if (ans1!=out1) output_message(0,"Wrong answer!");
    if (ans2!=out2) output_message(0.5,"Partially correct!");
    output_message(1,"OK!");
    cout << endl ;
    return 0;
}

