#include<bits/stdc++.h>
#define ll long long
#define f first
#define s second
using namespace std;
const ll maxn=2e5+10;
ll n,m;
struct Edge
{
    ll to,p,c;
};
vector<Edge> edges[maxn];
bool visited[maxn];
int parent[maxn],sz[maxn];
ll Dijkstra(ll limit)
{
    priority_queue<pair<ll,ll>> pq;
    vector<ll> dist(n+1,LLONG_MAX/2);
    pq.push({0,1});
    dist[1]=0;
    while(!pq.empty())
    {
        ll curr=pq.top().s;
        ll path=-pq.top().f;
        pq.pop();
        if(dist[curr]<path) continue;
        for(auto e:edges[curr])
        {
            if(e.p>limit) continue;
            if(dist[e.to]>path+e.c)
            {
                dist[e.to]=path+e.c;
                pq.push({-dist[e.to],e.to});
            }
        }
    }
    if(dist[n]==LLONG_MAX/2) return 0;
    return dist[n];
}
int findd(int u)
{
    if(parent[u]==0) return u;
    return parent[u]=findd(parent[u]);
}
void unite(int u,int v)
{
    u=findd(u);
    v=findd(v);
    if(u==v) return;
    if(sz[u]<sz[v]) swap(u,v);
    parent[v]=u;
    sz[u]+=sz[v];
}
struct Edge_start
{
    ll u,v,p;
};
bool cmp(Edge_start e1,Edge_start e2)
{
    return e1.p<e2.p;
}
vector<Edge_start> all_edges;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++) sz[i]=1;
    for(ll i=0;i<m;i++)
    {
        ll u,v,tp,tc;
        cin>>u>>v>>tp>>tc;
        edges[u].push_back({v,tp,tc});
        edges[v].push_back({u,tp,tc});
        all_edges.push_back({u,v,tp});
    }
    sort(all_edges.begin(),all_edges.end(),cmp);
    ll res;
    for(auto e:all_edges)
    {
        unite(e.u,e.v);
        if(findd(1)==findd(n))
        {
            res=e.p;
            break;
        }
    }
    cout<<res<<" "<<Dijkstra(res)<<"\n";

}
/*
5 7
1 3 1 1
1 5 4 5
2 4 3 4
2 5 1 2
1 2 1 6
3 5 2 5
4 5 1 1
*/




