#include<bits/stdc++.h>
#define ll long long
#define f first
#define s second
using namespace std;
const ll maxn=11;
ll n,m;
struct Edge
{
    ll to,p,c;
};
vector<Edge> edges[maxn];
bool visited[maxn];
pair<ll,ll> best;
void dfs(ll start,pair<ll,ll> currbest)
{
    if(start==n)
    {
        best=min(best,currbest);
        return;
    }
    visited[start]=1;
    for(auto e:edges[start])
    {
        if(visited[e.to]) continue;
        pair<ll,ll> newcurr=currbest;
        newcurr.f=max(newcurr.f,e.p);
        newcurr.s+=e.c;
        dfs(e.to,newcurr);
    }
    visited[start]=0;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(ll i=0;i<m;i++)
    {
        ll u,v,tp,tc;
        cin>>u>>v>>tp>>tc;
        edges[u].push_back({v,tp,tc});
        edges[v].push_back({u,tp,tc});
    }
    best={LLONG_MAX,LLONG_MAX};
    dfs(1,{0,0});
    cout<<best.f<<" "<<best.s<<"\n";
}
/*
5 7
1 3 1 1
1 5 4 5
2 4 3 4
2 5 1 2
1 2 1 6
3 5 2 5
4 5 1 1
*/
